#ifndef _LIB_H_
#define _LIB_H_
#include <sys.h>
#include <lib/stdarg.h>
#include <lib/string.h>

extern char* copy(const char* src, char* dst);
extern char* convint(int n, char* out);

extern "C" bool lib_init();
extern void flog(log_sev sev, const char* fmt, ...);
extern void writevterm_n(natl vterm, const char* vetto, int quanti);
extern void vterm_setcolor(natl vterm, int fgcol, int bgcol, bool blink = false);
extern bool vterm_setresident(natl vterm);
extern void vterm_clear(natl vterm);
extern void vterm_shutdown();
extern bool vterm_scroll(int v, int n);
extern void vterm_switch(natl v);
extern int printf(int term, const char *fmt, ...);
extern void* mem_alloc(natl dim);
extern void mem_free(void* p);
extern void perror(int a, const char *str);

struct vterm_edit_status {
	natl validi;
	natl cursore;
};

#define VTERM_NOECHO ((vterm_edit_status*)1)

extern int readvterm_n(natl vterm, char* vetti, int quanti, vterm_edit_status* stat = 0);
extern int readvterm_ln(natl vterm, char* vetti, int quanti, vterm_edit_status* stat = 0);

#endif
