#line 1 "utente/prog/logger.in"
#include <sys.h>
#include <lib.h>
#include <colors.h>


#line 6 "utente/prog/logger.in"

#line 7 "utente/prog/logger.in"

#line 9 "utente/prog/logger.in"
log_msg __logger_buf;
log_msg __logger_msg;

const char *__logger_sev_names[] = { "DBG", "INF", "WRN", "ERR" };
int __logger_sev_fgcol[]  = { COL_WHITE, COL_GREEN, COL_RED, COL_BLACK };
int __logger_sev_bgcol[]  = { COL_BLACK, COL_BLACK, COL_BLACK, COL_RED };

enum __logger_cmd_types { NEW_MSG, QUIT } __logger_cmd;

extern int __logger_non_busy;
#line 19 "utente/prog/logger.in"
extern int __logger_new_cmd;
#line 20 "utente/prog/logger.in"
extern int __logger_mutex;
#line 22 "utente/prog/logger.in"
void __logger_send_cmd(__logger_cmd_types cmd)
{
	sem_wait(__logger_mutex);
	sem_wait(__logger_non_busy);
	__logger_cmd = cmd;
	__logger_msg = __logger_buf;
	sem_signal(__logger_new_cmd);
	sem_signal(__logger_mutex);
}

__logger_cmd_types __logger_recv_cmd(log_msg& msg)
{
	__logger_cmd_types work;
	sem_wait(__logger_new_cmd);
	work = __logger_cmd;
	msg = __logger_msg;
	sem_signal(__logger_non_busy);
	return work;
}

bool __logger_quit = false;

void __logger_main(int a)
#line 45 "utente/prog/logger.in"
{
	__logger_cmd_types my_cmd;
	log_msg my_msg;

	if (!vterm_setresident(a)) {
		flog(LOG_WARN, "log di sistema non residente");
	}

	while (!__logger_quit) {
		my_cmd = __logger_recv_cmd(my_msg);
		switch (my_cmd) {
		case NEW_MSG:
			vterm_setcolor(a, __logger_sev_fgcol[my_msg.sev],
					  __logger_sev_bgcol[my_msg.sev]);
			printf(a, "%s %d\t%s\n", __logger_sev_names[my_msg.sev],
						 my_msg.identifier,
						 my_msg.msg);
			break;
		default:
			break;
		}
	}
	printf(a, "*** logger (main) terminato ***\n");

	terminate_p();
}
void __logger_reader(int a)
#line 71 "utente/prog/logger.in"
{

	if (!resident(&__logger_buf, sizeof(__logger_buf)))
		goto out;

	while (!__logger_quit) {
		readlog(__logger_buf);
		if (!__logger_quit) {
			__logger_send_cmd(NEW_MSG);
		}
	}

out:
	printf(a, "*** logger (reader) terminato ***\n");

	terminate_p();
}
char __logger_ctrl_buf;

void __logger_ctrl(int a)
#line 90 "utente/prog/logger.in"
{
	
	for (;;) {
		readvterm_n(a, &__logger_ctrl_buf, 1, VTERM_NOECHO);
		switch (__logger_ctrl_buf) {
		case 'Q':
			vterm_shutdown();
			delay(5);
			__logger_quit = true;
			__logger_send_cmd(QUIT);
			*(int *)0 = 1;
			break;
		case 'I':
			dump(DUMP_IOAPIC);
			break;
		case 'P':
			dump(DUMP_PROC);
			break;
		case 'S':
			dump(DUMP_SEM);
			break;
		default:
			break;
		}
	}

	terminate_p();
}
#line 1 "utente/prog/mouse.in"
#include <sys.h>
#include <lib.h>
#include <mouse.h>


#line 7 "utente/prog/mouse.in"
void mouse_main(int a)
#line 8 "utente/prog/mouse.in"
{
	mousemsg mm;

	for (;;) {
		get_mouse_events(&mm);

		switch(mm.type)
		{
			case MM_MOVE:
				//printf/(a, "Mouse pos:(%d,%d) vterm:%d abspos:(%d,%d)\n",mm.pos.x,mm.pos.y,mm.vterm,mm.abspos.x,mm.abspos.y);
				break;
			case MM_LBUTTONDOWN:
				//printf/(a, "Left button pressed \n");
				vterm_switch(mm.vterm);
				break;
			case MM_LBUTTONUP:
				//printf/(a, "Left button releases \n");
				break;
			case MM_MBUTTONDOWN:
				//printf/(a, "Middle button pressed \n");
				break;
			case MM_MBUTTONUP:
				//printf/(a, "Middle button releases \n");
				break;
			case MM_RBUTTONDOWN:
				//printf/(a, "Right button pressed \n");
				break;
			case MM_RBUTTONUP:
				//printf/(a, "Right button released \n");
				break;
			case MM_SCROLL:
				if(vterm_scroll(mm.vterm, mm.scroll))
					//printf/(a, "Scrolling by:%d \n", mm.scroll);
				break;
			case MM_HSCROLL:
				//printf/(a, "horizontal scrolling by:%d \n", mm.scroll);
				break;
		}
	}
	//printf/(a, "fine\n");


	terminate_p();
}
#line 182 "utente/utente.cpp"
short __logger_p0;
short __logger_p1;
short __logger_p2;
int __logger_non_busy;
int __logger_new_cmd;
int __logger_mutex;
short proc_mousehandler;

int main()
{
		__logger_p0 = activate_p(__logger_main, 1, 201, LIV_UTENTE);
	__logger_p1 = activate_p(__logger_reader, 1, 200, LIV_UTENTE);
	__logger_p2 = activate_p(__logger_ctrl, 1, 200, LIV_UTENTE);
	__logger_non_busy = sem_ini(1);
	__logger_new_cmd = sem_ini(0);
	__logger_mutex = sem_ini(1);
	proc_mousehandler = activate_p(mouse_main, 2, 10, LIV_UTENTE);

	terminate_p();
}
